<!DOCTYPE HTML PUBLIC "-//W3C//DTD HTML 4.01 Transitional//EN" "http://www.w3.org/TR/html4/loose.dtd">
<!-- NewPage -->
<html lang="en">
<head>
<!-- Generated by javadoc (version 1.7.0_67) on Wed Sep 10 14:57:27 CEST 2014 -->
<title>Base64.OutputStream</title>
<meta name="date" content="2014-09-10">
<link rel="stylesheet" type="text/css" href="../../../stylesheet.css" title="Style">
</head>
<body>
<script type="text/javascript"><!--
    if (location.href.indexOf('is-external=true') == -1) {
        parent.document.title="Base64.OutputStream";
    }
//-->
</script>
<noscript>
<div>JavaScript is disabled on your browser.</div>
</noscript>
<!-- ========= START OF TOP NAVBAR ======= -->
<div class="topNav"><a name="navbar_top">
<!--   -->
</a><a href="#skip-navbar_top" title="Skip navigation links"></a><a name="navbar_top_firstrow">
<!--   -->
</a>
<ul class="navList" title="Navigation">
<li><a href="../../../overview-summary.html">Overview</a></li>
<li><a href="package-summary.html">Package</a></li>
<li class="navBarCell1Rev">Class</li>
<li><a href="class-use/Base64.OutputStream.html">Use</a></li>
<li><a href="package-tree.html">Tree</a></li>
<li><a href="../../../deprecated-list.html">Deprecated</a></li>
<li><a href="../../../index-files/index-1.html">Index</a></li>
<li><a href="../../../help-doc.html">Help</a></li>
</ul>
</div>
<div class="subNav">
<ul class="navList">
<li><a href="../../../org/java_websocket/util/Base64.InputStream.html" title="class in org.java_websocket.util"><span class="strong">Prev Class</span></a></li>
<li><a href="../../../org/java_websocket/util/Charsetfunctions.html" title="class in org.java_websocket.util"><span class="strong">Next Class</span></a></li>
</ul>
<ul class="navList">
<li><a href="../../../index.html?org/java_websocket/util/Base64.OutputStream.html" target="_top">Frames</a></li>
<li><a href="Base64.OutputStream.html" target="_top">No Frames</a></li>
</ul>
<ul class="navList" id="allclasses_navbar_top">
<li><a href="../../../allclasses-noframe.html">All Classes</a></li>
</ul>
<div>
<script type="text/javascript"><!--
  allClassesLink = document.getElementById("allclasses_navbar_top");
  if(window==top) {
    allClassesLink.style.display = "block";
  }
  else {
    allClassesLink.style.display = "none";
  }
  //-->
</script>
</div>
<div>
<ul class="subNavList">
<li>Summary:&nbsp;</li>
<li>Nested&nbsp;|&nbsp;</li>
<li><a href="#field_summary">Field</a>&nbsp;|&nbsp;</li>
<li><a href="#constructor_summary">Constr</a>&nbsp;|&nbsp;</li>
<li><a href="#method_summary">Method</a></li>
</ul>
<ul class="subNavList">
<li>Detail:&nbsp;</li>
<li><a href="#field_detail">Field</a>&nbsp;|&nbsp;</li>
<li><a href="#constructor_detail">Constr</a>&nbsp;|&nbsp;</li>
<li><a href="#method_detail">Method</a></li>
</ul>
</div>
<a name="skip-navbar_top">
<!--   -->
</a></div>
<!-- ========= END OF TOP NAVBAR ========= -->
<!-- ======== START OF CLASS DATA ======== -->
<div class="header">
<div class="subTitle">org.java_websocket.util</div>
<h2 title="Class Base64.OutputStream" class="title">Class Base64.OutputStream</h2>
</div>
<div class="contentContainer">
<ul class="inheritance">
<li>java.lang.Object</li>
<li>
<ul class="inheritance">
<li>java.io.OutputStream</li>
<li>
<ul class="inheritance">
<li>java.io.FilterOutputStream</li>
<li>
<ul class="inheritance">
<li>org.java_websocket.util.Base64.OutputStream</li>
</ul>
</li>
</ul>
</li>
</ul>
</li>
</ul>
<div class="description">
<ul class="blockList">
<li class="blockList">
<dl>
<dt>All Implemented Interfaces:</dt>
<dd>java.io.Closeable, java.io.Flushable, java.lang.AutoCloseable</dd>
</dl>
<dl>
<dt>Enclosing class:</dt>
<dd><a href="../../../org/java_websocket/util/Base64.html" title="class in org.java_websocket.util">Base64</a></dd>
</dl>
<hr>
<br>
<pre>public static class <span class="strong">Base64.OutputStream</span>
extends java.io.FilterOutputStream</pre>
<div class="block">A <a href="../../../org/java_websocket/util/Base64.OutputStream.html" title="class in org.java_websocket.util"><code>Base64.OutputStream</code></a> will write data to another
 <tt>java.io.OutputStream</tt>, given in the constructor,
 and encode/decode to/from Base64 notation on the fly.</div>
<dl><dt><span class="strong">Since:</span></dt>
  <dd>1.3</dd>
<dt><span class="strong">See Also:</span></dt><dd><a href="../../../org/java_websocket/util/Base64.html" title="class in org.java_websocket.util"><code>Base64</code></a></dd></dl>
</li>
</ul>
</div>
<div class="summary">
<ul class="blockList">
<li class="blockList">
<!-- =========== FIELD SUMMARY =========== -->
<ul class="blockList">
<li class="blockList"><a name="field_summary">
<!--   -->
</a>
<h3>Field Summary</h3>
<table class="overviewSummary" border="0" cellpadding="3" cellspacing="0" summary="Field Summary table, listing fields, and an explanation">
<caption><span>Fields</span><span class="tabEnd">&nbsp;</span></caption>
<tr>
<th class="colFirst" scope="col">Modifier and Type</th>
<th class="colLast" scope="col">Field and Description</th>
</tr>
<tr class="altColor">
<td class="colFirst"><code>private byte[]</code></td>
<td class="colLast"><code><strong><a href="../../../org/java_websocket/util/Base64.OutputStream.html#b4">b4</a></strong></code>&nbsp;</td>
</tr>
<tr class="rowColor">
<td class="colFirst"><code>private boolean</code></td>
<td class="colLast"><code><strong><a href="../../../org/java_websocket/util/Base64.OutputStream.html#breakLines">breakLines</a></strong></code>&nbsp;</td>
</tr>
<tr class="altColor">
<td class="colFirst"><code>private byte[]</code></td>
<td class="colLast"><code><strong><a href="../../../org/java_websocket/util/Base64.OutputStream.html#buffer">buffer</a></strong></code>&nbsp;</td>
</tr>
<tr class="rowColor">
<td class="colFirst"><code>private int</code></td>
<td class="colLast"><code><strong><a href="../../../org/java_websocket/util/Base64.OutputStream.html#bufferLength">bufferLength</a></strong></code>&nbsp;</td>
</tr>
<tr class="altColor">
<td class="colFirst"><code>private byte[]</code></td>
<td class="colLast"><code><strong><a href="../../../org/java_websocket/util/Base64.OutputStream.html#decodabet">decodabet</a></strong></code>&nbsp;</td>
</tr>
<tr class="rowColor">
<td class="colFirst"><code>private boolean</code></td>
<td class="colLast"><code><strong><a href="../../../org/java_websocket/util/Base64.OutputStream.html#encode">encode</a></strong></code>&nbsp;</td>
</tr>
<tr class="altColor">
<td class="colFirst"><code>private int</code></td>
<td class="colLast"><code><strong><a href="../../../org/java_websocket/util/Base64.OutputStream.html#lineLength">lineLength</a></strong></code>&nbsp;</td>
</tr>
<tr class="rowColor">
<td class="colFirst"><code>private int</code></td>
<td class="colLast"><code><strong><a href="../../../org/java_websocket/util/Base64.OutputStream.html#options">options</a></strong></code>&nbsp;</td>
</tr>
<tr class="altColor">
<td class="colFirst"><code>private int</code></td>
<td class="colLast"><code><strong><a href="../../../org/java_websocket/util/Base64.OutputStream.html#position">position</a></strong></code>&nbsp;</td>
</tr>
<tr class="rowColor">
<td class="colFirst"><code>private boolean</code></td>
<td class="colLast"><code><strong><a href="../../../org/java_websocket/util/Base64.OutputStream.html#suspendEncoding">suspendEncoding</a></strong></code>&nbsp;</td>
</tr>
</table>
<ul class="blockList">
<li class="blockList"><a name="fields_inherited_from_class_java.io.FilterOutputStream">
<!--   -->
</a>
<h3>Fields inherited from class&nbsp;java.io.FilterOutputStream</h3>
<code>out</code></li>
</ul>
</li>
</ul>
<!-- ======== CONSTRUCTOR SUMMARY ======== -->
<ul class="blockList">
<li class="blockList"><a name="constructor_summary">
<!--   -->
</a>
<h3>Constructor Summary</h3>
<table class="overviewSummary" border="0" cellpadding="3" cellspacing="0" summary="Constructor Summary table, listing constructors, and an explanation">
<caption><span>Constructors</span><span class="tabEnd">&nbsp;</span></caption>
<tr>
<th class="colOne" scope="col">Constructor and Description</th>
</tr>
<tr class="altColor">
<td class="colOne"><code><strong><a href="../../../org/java_websocket/util/Base64.OutputStream.html#Base64.OutputStream(java.io.OutputStream)">Base64.OutputStream</a></strong>(java.io.OutputStream&nbsp;out)</code>
<div class="block">Constructs a <a href="../../../org/java_websocket/util/Base64.OutputStream.html" title="class in org.java_websocket.util"><code>Base64.OutputStream</code></a> in ENCODE mode.</div>
</td>
</tr>
<tr class="rowColor">
<td class="colOne"><code><strong><a href="../../../org/java_websocket/util/Base64.OutputStream.html#Base64.OutputStream(java.io.OutputStream,%20int)">Base64.OutputStream</a></strong>(java.io.OutputStream&nbsp;out,
                   int&nbsp;options)</code>
<div class="block">Constructs a <a href="../../../org/java_websocket/util/Base64.OutputStream.html" title="class in org.java_websocket.util"><code>Base64.OutputStream</code></a> in
 either ENCODE or DECODE mode.</div>
</td>
</tr>
</table>
</li>
</ul>
<!-- ========== METHOD SUMMARY =========== -->
<ul class="blockList">
<li class="blockList"><a name="method_summary">
<!--   -->
</a>
<h3>Method Summary</h3>
<table class="overviewSummary" border="0" cellpadding="3" cellspacing="0" summary="Method Summary table, listing methods, and an explanation">
<caption><span>Methods</span><span class="tabEnd">&nbsp;</span></caption>
<tr>
<th class="colFirst" scope="col">Modifier and Type</th>
<th class="colLast" scope="col">Method and Description</th>
</tr>
<tr class="altColor">
<td class="colFirst"><code>void</code></td>
<td class="colLast"><code><strong><a href="../../../org/java_websocket/util/Base64.OutputStream.html#close()">close</a></strong>()</code>
<div class="block">Flushes and closes (I think, in the superclass) the stream.</div>
</td>
</tr>
<tr class="rowColor">
<td class="colFirst"><code>void</code></td>
<td class="colLast"><code><strong><a href="../../../org/java_websocket/util/Base64.OutputStream.html#flushBase64()">flushBase64</a></strong>()</code>
<div class="block">Method added by PHIL.</div>
</td>
</tr>
<tr class="altColor">
<td class="colFirst"><code>void</code></td>
<td class="colLast"><code><strong><a href="../../../org/java_websocket/util/Base64.OutputStream.html#resumeEncoding()">resumeEncoding</a></strong>()</code>
<div class="block">Resumes encoding of the stream.</div>
</td>
</tr>
<tr class="rowColor">
<td class="colFirst"><code>void</code></td>
<td class="colLast"><code><strong><a href="../../../org/java_websocket/util/Base64.OutputStream.html#suspendEncoding()">suspendEncoding</a></strong>()</code>
<div class="block">Suspends encoding of the stream.</div>
</td>
</tr>
<tr class="altColor">
<td class="colFirst"><code>void</code></td>
<td class="colLast"><code><strong><a href="../../../org/java_websocket/util/Base64.OutputStream.html#write(byte[],%20int,%20int)">write</a></strong>(byte[]&nbsp;theBytes,
     int&nbsp;off,
     int&nbsp;len)</code>
<div class="block">Calls <a href="../../../org/java_websocket/util/Base64.OutputStream.html#write(int)"><code>write(int)</code></a> repeatedly until <var>len</var> 
 bytes are written.</div>
</td>
</tr>
<tr class="rowColor">
<td class="colFirst"><code>void</code></td>
<td class="colLast"><code><strong><a href="../../../org/java_websocket/util/Base64.OutputStream.html#write(int)">write</a></strong>(int&nbsp;theByte)</code>
<div class="block">Writes the byte to the output stream after
 converting to/from Base64 notation.</div>
</td>
</tr>
</table>
<ul class="blockList">
<li class="blockList"><a name="methods_inherited_from_class_java.io.FilterOutputStream">
<!--   -->
</a>
<h3>Methods inherited from class&nbsp;java.io.FilterOutputStream</h3>
<code>flush, write</code></li>
</ul>
<ul class="blockList">
<li class="blockList"><a name="methods_inherited_from_class_java.lang.Object">
<!--   -->
</a>
<h3>Methods inherited from class&nbsp;java.lang.Object</h3>
<code>clone, equals, finalize, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait</code></li>
</ul>
</li>
</ul>
</li>
</ul>
</div>
<div class="details">
<ul class="blockList">
<li class="blockList">
<!-- ============ FIELD DETAIL =========== -->
<ul class="blockList">
<li class="blockList"><a name="field_detail">
<!--   -->
</a>
<h3>Field Detail</h3>
<a name="encode">
<!--   -->
</a>
<ul class="blockList">
<li class="blockList">
<h4>encode</h4>
<pre>private&nbsp;boolean encode</pre>
</li>
</ul>
<a name="position">
<!--   -->
</a>
<ul class="blockList">
<li class="blockList">
<h4>position</h4>
<pre>private&nbsp;int position</pre>
</li>
</ul>
<a name="buffer">
<!--   -->
</a>
<ul class="blockList">
<li class="blockList">
<h4>buffer</h4>
<pre>private&nbsp;byte[] buffer</pre>
</li>
</ul>
<a name="bufferLength">
<!--   -->
</a>
<ul class="blockList">
<li class="blockList">
<h4>bufferLength</h4>
<pre>private&nbsp;int bufferLength</pre>
</li>
</ul>
<a name="lineLength">
<!--   -->
</a>
<ul class="blockList">
<li class="blockList">
<h4>lineLength</h4>
<pre>private&nbsp;int lineLength</pre>
</li>
</ul>
<a name="breakLines">
<!--   -->
</a>
<ul class="blockList">
<li class="blockList">
<h4>breakLines</h4>
<pre>private&nbsp;boolean breakLines</pre>
</li>
</ul>
<a name="b4">
<!--   -->
</a>
<ul class="blockList">
<li class="blockList">
<h4>b4</h4>
<pre>private&nbsp;byte[] b4</pre>
</li>
</ul>
<a name="suspendEncoding">
<!--   -->
</a>
<ul class="blockList">
<li class="blockList">
<h4>suspendEncoding</h4>
<pre>private&nbsp;boolean suspendEncoding</pre>
</li>
</ul>
<a name="options">
<!--   -->
</a>
<ul class="blockList">
<li class="blockList">
<h4>options</h4>
<pre>private&nbsp;int options</pre>
</li>
</ul>
<a name="decodabet">
<!--   -->
</a>
<ul class="blockListLast">
<li class="blockList">
<h4>decodabet</h4>
<pre>private&nbsp;byte[] decodabet</pre>
</li>
</ul>
</li>
</ul>
<!-- ========= CONSTRUCTOR DETAIL ======== -->
<ul class="blockList">
<li class="blockList"><a name="constructor_detail">
<!--   -->
</a>
<h3>Constructor Detail</h3>
<a name="Base64.OutputStream(java.io.OutputStream)">
<!--   -->
</a>
<ul class="blockList">
<li class="blockList">
<h4>Base64.OutputStream</h4>
<pre>public&nbsp;Base64.OutputStream(java.io.OutputStream&nbsp;out)</pre>
<div class="block">Constructs a <a href="../../../org/java_websocket/util/Base64.OutputStream.html" title="class in org.java_websocket.util"><code>Base64.OutputStream</code></a> in ENCODE mode.</div>
<dl><dt><span class="strong">Parameters:</span></dt><dd><code>out</code> - the <tt>java.io.OutputStream</tt> to which data will be written.</dd><dt><span class="strong">Since:</span></dt>
  <dd>1.3</dd></dl>
</li>
</ul>
<a name="Base64.OutputStream(java.io.OutputStream, int)">
<!--   -->
</a>
<ul class="blockListLast">
<li class="blockList">
<h4>Base64.OutputStream</h4>
<pre>public&nbsp;Base64.OutputStream(java.io.OutputStream&nbsp;out,
                   int&nbsp;options)</pre>
<div class="block">Constructs a <a href="../../../org/java_websocket/util/Base64.OutputStream.html" title="class in org.java_websocket.util"><code>Base64.OutputStream</code></a> in
 either ENCODE or DECODE mode.
 <p>
 Valid options:<pre>
   ENCODE or DECODE: Encode or Decode as data is read.
   DO_BREAK_LINES: don't break lines at 76 characters
     (only meaningful when encoding)</i>
 </pre>
 <p>
 Example: <code>new Base64.OutputStream( out, Base64.ENCODE )</code></div>
<dl><dt><span class="strong">Parameters:</span></dt><dd><code>out</code> - the <tt>java.io.OutputStream</tt> to which data will be written.</dd><dd><code>options</code> - Specified options.</dd><dt><span class="strong">Since:</span></dt>
  <dd>1.3</dd>
<dt><span class="strong">See Also:</span></dt><dd><a href="../../../org/java_websocket/util/Base64.html#ENCODE"><code>Base64.ENCODE</code></a>, 
<a href="../../../org/java_websocket/util/Base64.html#DECODE"><code>Base64.DECODE</code></a>, 
<a href="../../../org/java_websocket/util/Base64.html#DO_BREAK_LINES"><code>Base64.DO_BREAK_LINES</code></a></dd></dl>
</li>
</ul>
</li>
</ul>
<!-- ============ METHOD DETAIL ========== -->
<ul class="blockList">
<li class="blockList"><a name="method_detail">
<!--   -->
</a>
<h3>Method Detail</h3>
<a name="write(int)">
<!--   -->
</a>
<ul class="blockList">
<li class="blockList">
<h4>write</h4>
<pre>public&nbsp;void&nbsp;write(int&nbsp;theByte)
           throws java.io.IOException</pre>
<div class="block">Writes the byte to the output stream after
 converting to/from Base64 notation.
 When encoding, bytes are buffered three
 at a time before the output stream actually
 gets a write() call.
 When decoding, bytes are buffered four
 at a time.</div>
<dl>
<dt><strong>Overrides:</strong></dt>
<dd><code>write</code>&nbsp;in class&nbsp;<code>java.io.FilterOutputStream</code></dd>
<dt><span class="strong">Parameters:</span></dt><dd><code>theByte</code> - the byte to write</dd>
<dt><span class="strong">Throws:</span></dt>
<dd><code>java.io.IOException</code></dd><dt><span class="strong">Since:</span></dt>
  <dd>1.3</dd></dl>
</li>
</ul>
<a name="write(byte[], int, int)">
<!--   -->
</a>
<ul class="blockList">
<li class="blockList">
<h4>write</h4>
<pre>public&nbsp;void&nbsp;write(byte[]&nbsp;theBytes,
         int&nbsp;off,
         int&nbsp;len)
           throws java.io.IOException</pre>
<div class="block">Calls <a href="../../../org/java_websocket/util/Base64.OutputStream.html#write(int)"><code>write(int)</code></a> repeatedly until <var>len</var> 
 bytes are written.</div>
<dl>
<dt><strong>Overrides:</strong></dt>
<dd><code>write</code>&nbsp;in class&nbsp;<code>java.io.FilterOutputStream</code></dd>
<dt><span class="strong">Parameters:</span></dt><dd><code>theBytes</code> - array from which to read bytes</dd><dd><code>off</code> - offset for array</dd><dd><code>len</code> - max number of bytes to read into array</dd>
<dt><span class="strong">Throws:</span></dt>
<dd><code>java.io.IOException</code></dd><dt><span class="strong">Since:</span></dt>
  <dd>1.3</dd></dl>
</li>
</ul>
<a name="flushBase64()">
<!--   -->
</a>
<ul class="blockList">
<li class="blockList">
<h4>flushBase64</h4>
<pre>public&nbsp;void&nbsp;flushBase64()
                 throws java.io.IOException</pre>
<div class="block">Method added by PHIL. [Thanks, PHIL. -Rob]
 This pads the buffer without closing the stream.</div>
<dl><dt><span class="strong">Throws:</span></dt>
<dd><code>java.io.IOException</code> - if there's an error.</dd></dl>
</li>
</ul>
<a name="close()">
<!--   -->
</a>
<ul class="blockList">
<li class="blockList">
<h4>close</h4>
<pre>public&nbsp;void&nbsp;close()
           throws java.io.IOException</pre>
<div class="block">Flushes and closes (I think, in the superclass) the stream.</div>
<dl>
<dt><strong>Specified by:</strong></dt>
<dd><code>close</code>&nbsp;in interface&nbsp;<code>java.io.Closeable</code></dd>
<dt><strong>Specified by:</strong></dt>
<dd><code>close</code>&nbsp;in interface&nbsp;<code>java.lang.AutoCloseable</code></dd>
<dt><strong>Overrides:</strong></dt>
<dd><code>close</code>&nbsp;in class&nbsp;<code>java.io.FilterOutputStream</code></dd>
<dt><span class="strong">Throws:</span></dt>
<dd><code>java.io.IOException</code></dd><dt><span class="strong">Since:</span></dt>
  <dd>1.3</dd></dl>
</li>
</ul>
<a name="suspendEncoding()">
<!--   -->
</a>
<ul class="blockList">
<li class="blockList">
<h4>suspendEncoding</h4>
<pre>public&nbsp;void&nbsp;suspendEncoding()
                     throws java.io.IOException</pre>
<div class="block">Suspends encoding of the stream.
 May be helpful if you need to embed a piece of
 base64-encoded data in a stream.</div>
<dl><dt><span class="strong">Throws:</span></dt>
<dd><code>java.io.IOException</code> - if there's an error flushing</dd><dt><span class="strong">Since:</span></dt>
  <dd>1.5.1</dd></dl>
</li>
</ul>
<a name="resumeEncoding()">
<!--   -->
</a>
<ul class="blockListLast">
<li class="blockList">
<h4>resumeEncoding</h4>
<pre>public&nbsp;void&nbsp;resumeEncoding()</pre>
<div class="block">Resumes encoding of the stream.
 May be helpful if you need to embed a piece of
 base64-encoded data in a stream.</div>
<dl><dt><span class="strong">Since:</span></dt>
  <dd>1.5.1</dd></dl>
</li>
</ul>
</li>
</ul>
</li>
</ul>
</div>
</div>
<!-- ========= END OF CLASS DATA ========= -->
<!-- ======= START OF BOTTOM NAVBAR ====== -->
<div class="bottomNav"><a name="navbar_bottom">
<!--   -->
</a><a href="#skip-navbar_bottom" title="Skip navigation links"></a><a name="navbar_bottom_firstrow">
<!--   -->
</a>
<ul class="navList" title="Navigation">
<li><a href="../../../overview-summary.html">Overview</a></li>
<li><a href="package-summary.html">Package</a></li>
<li class="navBarCell1Rev">Class</li>
<li><a href="class-use/Base64.OutputStream.html">Use</a></li>
<li><a href="package-tree.html">Tree</a></li>
<li><a href="../../../deprecated-list.html">Deprecated</a></li>
<li><a href="../../../index-files/index-1.html">Index</a></li>
<li><a href="../../../help-doc.html">Help</a></li>
</ul>
</div>
<div class="subNav">
<ul class="navList">
<li><a href="../../../org/java_websocket/util/Base64.InputStream.html" title="class in org.java_websocket.util"><span class="strong">Prev Class</span></a></li>
<li><a href="../../../org/java_websocket/util/Charsetfunctions.html" title="class in org.java_websocket.util"><span class="strong">Next Class</span></a></li>
</ul>
<ul class="navList">
<li><a href="../../../index.html?org/java_websocket/util/Base64.OutputStream.html" target="_top">Frames</a></li>
<li><a href="Base64.OutputStream.html" target="_top">No Frames</a></li>
</ul>
<ul class="navList" id="allclasses_navbar_bottom">
<li><a href="../../../allclasses-noframe.html">All Classes</a></li>
</ul>
<div>
<script type="text/javascript"><!--
  allClassesLink = document.getElementById("allclasses_navbar_bottom");
  if(window==top) {
    allClassesLink.style.display = "block";
  }
  else {
    allClassesLink.style.display = "none";
  }
  //-->
</script>
</div>
<div>
<ul class="subNavList">
<li>Summary:&nbsp;</li>
<li>Nested&nbsp;|&nbsp;</li>
<li><a href="#field_summary">Field</a>&nbsp;|&nbsp;</li>
<li><a href="#constructor_summary">Constr</a>&nbsp;|&nbsp;</li>
<li><a href="#method_summary">Method</a></li>
</ul>
<ul class="subNavList">
<li>Detail:&nbsp;</li>
<li><a href="#field_detail">Field</a>&nbsp;|&nbsp;</li>
<li><a href="#constructor_detail">Constr</a>&nbsp;|&nbsp;</li>
<li><a href="#method_detail">Method</a></li>
</ul>
</div>
<a name="skip-navbar_bottom">
<!--   -->
</a></div>
<!-- ======== END OF BOTTOM NAVBAR ======= -->
</body>
</html>
